unit main;

{$ifdef FPC}{$mode objfpc}{$h+}{$endif}

interface

uses
 msetypes,mseglob,mseguiglob,mseguiintf,mseapplication,msestat,msemenus,msegui,
 msegraphics,msegraphutils,mseevent,mseclasses,msewidgets,mseforms,msedataedits,
 mseedit,msegrids,mseificomp,mseificompglob,mseifiglob,msestatfile,msestream,
 msestrings,msewidgetgrid,sysutils,mseeditglob,msetextedit,msecolordialog,
 msesyntaxedit,msedispwidgets,mserichstring;

type
 tmainfo = class(tmainform)
   grid: twidgetgrid;
   tcoloredit1: tcoloredit;
   edit: tsyntaxedit;
   tstringdisp1: tstringdisp;
   procedure main_on_create(const sender: TObject);
   procedure edit_on_event(const sender: TObject; var info: celleventinfoty);
   procedure edit_notific(const sender: TObject;
                   var info: editnotificationinfoty);
   procedure mouse_event(const sender: TObject; var info: textmouseeventinfoty);
   procedure color_value(const sender: TObject; var avalue: colorty;
                   var accept: Boolean);
 end;
 
var
 mainfo: tmainfo;
 start_sel, end_sel, sel_row : integer;
 
implementation

uses
 main_mfm{,
 mserichstring};
 
procedure tmainfo.main_on_create(const sender: TObject);
var
   i_r : integer;
begin
  With grid do
  begin
    beginupdate;
    rowcount := 100;
    for i_r := 0 to rowcount - 1 do
    begin
      edit[i_r] := 'Проста перевірка ....'
                   + inttostr(random(100))
                   + ' ' + inttostr(random(500));
//updatefontstyle1(var formats: formatinfoarty; aindex: integer; len: halfinteger;
//                              astyle: fontstylety; aset: boolean): boolean; 

//setfontcolor(const formats: formatinfoarty; aindex: integer; 
//                       len: halfinteger; color: colorty): formatinfoarty;                  
      updatefontstyle1(edit.datalist.richitemspo[i_r]^.format, 7, 5, fs_bold,true);
      setfontcolor1(edit.datalist.richitemspo[i_r]^.format, 7, 5, $68A8A8);
      updatefontstyle1(edit.datalist.richitemspo[i_r]^.format, 14, 5, fs_bold,true);      
                       
    end;
    endupdate;
  end;
end;

procedure tmainfo.edit_on_event(const sender: TObject;
               var info: celleventinfoty);
begin
{  With info.cell do
  begin
    mainfo.caption := 'Row : ' + inttostr(row)
                      +'Col : ' + inttostr(col);
  end;}
end;

procedure tmainfo.edit_notific(const sender: TObject;
               var info: editnotificationinfoty);
var
  Pos_X, Pos_Y : integer; //not need but :) 
  pt1: pointty;              
begin
 case info.action of
  ea_indexmoved : begin
                    Pos_X := edit.editpos.row+1;
                    Pos_Y := edit.editpos.col; //+1;
                    mainfo.caption := 'Row: ' + inttostr(Pos_X) + ':'+ ' Col: ' + inttostr(Pos_Y);
                  //  edit.selectword
                  end;
 end;
end;

procedure tmainfo.mouse_event(const sender: TObject;
               var info: textmouseeventinfoty);
begin
  tstringdisp1.value := 'Start : ' + inttostr(edit.selectstart.col)
                        + 'End : ' + inttostr(edit.selectend.col);
  start_sel := edit.selectstart.col;
  end_sel := edit.selectend.col;
  sel_row := edit.selectstart.row;
end;

procedure tmainfo.color_value(const sender: TObject; var avalue: colorty;
               var accept: Boolean);
begin
  setfontcolor1(edit.datalist.richitemspo[sel_row]^.format, end_sel,
                 start_sel - end_sel, avalue);
end;

end.
